SystemOrganization addCategory: #HW3!

Number subclass: #NumberWithUnits
	instanceVariableNames: 'numValue units'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HW3'!

!NumberWithUnits commentStamp: '<historical>' prior: 0!
A NumberWithUnits stores unit of measurement in addition to a number value.

Instance Variables
	units:		<Object>
	value:		<Object>

units
	- xxxxx

value
	- xxxxx
!

!NumberWithUnits class methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/12/2013 01:25'!
value: aNumber unit: aSymbol

	| o |
	o := NumberWithUnits new.
	^ o value: aNumber unit: aSymbol.! !

!NumberWithUnits methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/12/2013 17:56'!
+ aNumber 
	"Answer the sum of the receiver and aNumber."

	|nu|
	aNumber isNumberWithUnits ifTrue: 
			[ 	nu := NumberWithUnits new.
			 	nu numValue: (self numValue + aNumber numValue).
				nu unitDict = aNumber unitDict
			]
	"	[d := denominator gcd: aNumber denominator.
		n := numerator * (d1 := aNumber denominator // d) + (aNumber numerator * (d2 := denominator // d)).
		d1 := d1 * d2.
		n := n // (d2 := n gcd: d).
		(d := d1 * (d // d2)) = 1 ifTrue: [^ n].
		^ Fraction numerator: n denominator: d].
	^ aNumber adaptToFraction: self andSend: #+"! !

!NumberWithUnits methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/12/2013 01:36'!
isNumberWithUnits

^ true! !

!NumberWithUnits methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/12/2013 01:43'!
numValue

^ numValue ! !

!NumberWithUnits methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/12/2013 01:48'!
numValue: aNumber

numValue := aNumber.! !

!NumberWithUnits methodsFor: 'printing' stamp: 'IsraSunhachawi 6/12/2013 01:13'!
printOn: aStream

aStream nextPutAll: numValue ! !

!NumberWithUnits methodsFor: 'printing' stamp: 'IsraSunhachawi 6/12/2013 01:18'!
printOn: aStream base: base

aStream nextPutAll:( numValue printString);
	nextPutAll: ' ';
	nextPutAll: (units printString).! !

!NumberWithUnits methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/12/2013 01:05'!
value: aNumber unit: aSymbol 

numValue := aNumber.
units := Units setUnit: aSymbol power: 1.
^ self.! !

Object subclass: #Units
	instanceVariableNames: 'unitDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HW3'!

!Units commentStamp: '<historical>' prior: 0!
Units stores the unit of measurement for a NumberWithUnits

Instance Variables
	unitDict:		<Object>

unitDict
	- xxxxx
!

!Units class methodsFor: 'adding' stamp: 'IsraSunhachawi 6/12/2013 00:37'!
setUnit: aSymbol power: aNumber

	| o |
	o := Units new.
	^ o setUnit: aSymbol power: aNumber! !

!Units methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/11/2013 23:57'!
= aUnit 

^(self unitDict = aUnit unitDict) ! !

!Units methodsFor: 'initialize-release' stamp: 'IsraSunhachawi 6/11/2013 23:35'!
initialize
	"initialize Units"

	unitDict := Dictionary new! !

!Units methodsFor: 'printing' stamp: 'IsraSunhachawi 6/11/2013 23:54'!
printOn: aStream 
	
	unitDict keysDo: 
		[:key| aStream 
				nextPutAll: key;
				nextPutAll: '^';
				nextPutAll: (unitDict at: key) printString;
				nextPutAll: ' ']
			
	! !

!Units methodsFor: 'adding' stamp: 'IsraSunhachawi 6/12/2013 00:06'!
setUnit: aSymbol power: aNumber
	"comment stating purpose of message"

	unitDict at: aSymbol put: aNumber.! !

!Units methodsFor: 'accessing' stamp: 'IsraSunhachawi 6/11/2013 23:34'!
unitDict

	^unitDict! !
